
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include "pesp_ioctl.h"



int main(){
  int hamaBuf_fd = 0;
  h_ccd_t ccd;
  int retval;


	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);

	if (hamaBuf_fd == -1) {
		perror("");
		return -1;
	}
	printf("hamaBuf_fd = %d\n", hamaBuf_fd);

/*********************************
struct _pespccd {
        int width, height, depth;
        struct timeval aet;
        char smd;
        char amd;
        char emd;
        unsigned short int ads;
        char atp;
        unsigned short int spx;
        int svo;
        int svw;
        int sho;
        int shw;
        char esc;
        unsigned short int ceg;
        unsigned short int ceo;
        char res;
};
**********************************/

        retval = ioctl(hamaBuf_fd,PESP_IOCG_CCD, &ccd);          /* Get by pointer */
	printf("retval = %d\n", retval);

	printf("ccd.width        = %d\n", ccd.width);
	printf("ccd.height       = %d\n", ccd.height);
	printf("ccd.depth        = %d\n", ccd.depth);
	printf("ccd.aet.tv_sec   = %d\n", ccd.aet.tv_sec);
	printf("ccd.aet.tv_usec  = %d\n", ccd.aet.tv_usec);
	printf("ccd.smd          = '%c'\n", ccd.smd);
	printf("ccd.amd          = '%c'\n", ccd.amd);
	printf("ccd.emd          = '%c'\n", ccd.emd);
	printf("ccd.ads          = %d\n", ccd.ads);
	printf("ccd.atp          = '%c'\n", ccd.atp);
	printf("ccd.spx          = %d\n", ccd.spx);
	printf("ccd.spy          = %d\n", ccd.spy);
	printf("ccd.svo          = %d\n", ccd.svo);
	printf("ccd.svw          = %d\n", ccd.svw);
	printf("ccd.sho          = %d\n", ccd.sho);
	printf("ccd.shw          = %d\n", ccd.shw);
	printf("ccd.esc          = '%c'\n", ccd.esc);
	printf("ccd.ceg          = %d\n", ccd.ceg);
	printf("ccd.ceo          = %d\n", ccd.ceo);
	printf("ccd.res          = '%c'\n", ccd.res);
        if ( (ccd.ccdtype>=CCD_UNKNOWN) && (ccd.ccdtype<=A_IKONM934) )
        	printf("ccd.ccdtype      = %s\n", CCDTypeName[ccd.ccdtype]);
        else
        	printf("ccd.ccdtype      = %d\n", ccd.ccdtype);
                printf("ccd.do_extra     = %d\n", ccd.do_extra);
	if (ccd.do_extra != 0) {
	        switch (ccd.ccdtype){
	        	case A_IKONM934:
	                	printf("ccd...cooling      = %d\n", ccd.priv_data.andor.cooling);
	                	printf("ccd...target_temp  = %d\n", ccd.priv_data.andor.target_temp);
	                	printf("ccd...cstatus      = %lu\n", ccd.priv_data.andor.cstatus);
	                	printf("ccd...temp         = %f\n", ccd.priv_data.andor.temp);
	                	printf("ccd...fast_trigger = %d\n", ccd.priv_data.andor.fast_trigger);
	                	printf("ccd...vsspeed      = %d\n", ccd.priv_data.andor.vsspeed);
	                	printf("ccd...readouttime  = %f\n", ccd.priv_data.andor.readouttime);
	                        break;
	                default: break;
	        }
	}

    	close(hamaBuf_fd);
}

