
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include "pesp_ioctl.h"

#include "h_types_2.h"
#include "lib_h_image.h"



void usage(){
	  printf("getDark darkfile\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){

  h_metaimg_t pespDark;
  h_metaimg_t metaimg;
  int size = 9000000;

  int hamaBuf_fd = 0;

  int retval;
  int fd0;

  char name[128]="";


	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************
**********************************/

	pespDark.data = malloc(size);
        memset(pespDark.data, 0, size);
	pespDark.info.size = size;


        retval = ioctl(hamaBuf_fd, PESP_IOCG_DARK, &pespDark);
        if (-1 == retval) {
                printf("%m on ioctl(PESP_IOCG_DARK)\n");
        }
	printf("read %d\n", pespDark.info.size);
	retval = h_dumpImageStruct(pespDark);

	if (pespDark.info.size > pespDark.info.info_size){
		retval = h_dumpImageInfo(pespDark);
	}

	if (argc >= 2) {
		printf("Writing %s\n", argv[1]);

		if (-1 == fd0)perror("fd0");

       		strcat(name, argv[1]);
        	strncat(name, ".dark", 128);
        	fd0 = open(name, O_CREAT | O_RDWR | O_TRUNC, S_IRUSR | S_IWUSR);

        	retval  = write(fd0, &pespDark.info, sizeof(h_data_struct_info_t));
        	retval += write(fd0, pespDark.data, pespDark.info.size - sizeof(h_data_struct_info_t));

        	printf("retval written = %d\n", retval);

		close(fd0);
	}


    	close(hamaBuf_fd);
}

