
#include <fcntl.h>
#include <sys/ioctl.h>


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <errno.h>
#include <sys/mman.h>
#include <sys/types.h> //shm_open
#include <stdio.h>  //printf
#include <stdlib.h> //exit
#include <unistd.h> //close
#include <string.h> //strerror

// gcc -lrt -o

#include <sys/time.h>
#include "pesp_ioctl.h"

#include <errno.h>

#include <sys/ioctl.h>


#include <utime.h>

#include <signal.h>
#include <stdarg.h>
#include <time.h>

#define _MYDBG1_
#undef _MYDBG1_

#define _MYDBG2_
#undef _MYDBG2_


int go=1;
void starthandler(int signum, siginfo_t *info, void *extra);
void  stophandler(int signum, siginfo_t *info, void *extra);


/*
 * main
 */
int
main(argc, argv)
int     argc;
char  **argv;
{

    int fd = 0;


//---------------------------

int j,ret,k,i;

struct timeval t0, t1, t2, t3;
float t;

h_img_t inbuf;

#define MAX_VAL_BUFF 20
float readtime[MAX_VAL_BUFF];
float repetitiontime[MAX_VAL_BUFF];
int retvalues[MAX_VAL_BUFF];

pid_t pid;

float readtime_avg;

//---------------------------



  struct sigaction act;
  sigset_t blockset, pending;
  int pendingcount;

  sigemptyset(&blockset);
  act.sa_mask = blockset;
  act.sa_flags = SA_SIGINFO;

  act.sa_sigaction = &starthandler;
  if (sigaction(SIGUSR1, &act, NULL) == -1) {
    printf("Couldn't register signal handler for SIGUSR1/start.\n");
  }

  act.sa_sigaction = &stophandler;
  if (sigaction(SIGUSR2, &act, NULL) == -1) {
    printf("Couldn't register signal handler for SIGUSR2/stop.\n");
  }

  /* blockset is still the empty set. */

  sigaddset(&blockset, SIGUSR1);
  sigaddset(&blockset, SIGUSR2);
//---------------------------

  pid = getpid();

  fd = open("/dev/pespImg0", O_RDWR); 
  if (-1 == fd)perror("hamaBuf_fd");
	
	while(1){
		k=0;
    		sigprocmask(SIG_BLOCK, &blockset, NULL);
		sigpending(&pending);
    		pendingcount = 0;
    		if (sigismember(&pending, SIGUSR1)) pendingcount++;
    		if (sigismember(&pending, SIGUSR2)) pendingcount++;
    		if (pendingcount) printf("There are %d signals pending.\n", pendingcount);
    		sigprocmask(SIG_UNBLOCK, &blockset, NULL);

		while(go){
#ifdef _MYDBG1_
			printf(STATE_FILE"%d ... ",k);
#endif /* _MYDBG1_ */
			fd_set fds;
                       	struct timeval tv, tr;
                        int r;

                        FD_ZERO (&fds);
                        FD_SET (fd, &fds);

                        /* Timeout. */
                        tv.tv_sec = 2;
                        tv.tv_usec = 0;

                        do {
                                r = select (fd + 1, &fds, NULL, NULL, &tv);
                                if ((-1 == r) && !(EINTR == errno)) perror("select");
                        } while ( ((-1 == r)&&(EINTR == errno)) );

                        if (0 == r) {
				printf("%d :: select timeout [k=%d]\n", pid, k);
				k = 0;
				for(i=0; i<k; i++){
					repetitiontime[i] = 0;
					readtime[i] = 0;
					retvalues[i] = 0;
				}
				gettimeofday(&t2, NULL);
                        } else {
				gettimeofday(&t3, NULL);
				#if 0
                                	t = ((float)(t3.tv_sec - t2.tv_sec))*1000  + ((float)t3.tv_usec - (float)t2.tv_usec)/1000;
				#else
			        	timersub(&t3, &t2, &tr);
					t = ((float)tr.tv_sec)*1000 + ((float)tr.tv_usec)/1000;
					if ( t > 100 ){
						printf("t = %f ms,   k= %d\n", t, k);
						printf("t2: tv_sec=%lu tv_usec=%lu\n", t2.tv_sec, t2.tv_usec);
						printf("t3: tv_sec=%lu tv_usec=%lu\n", t3.tv_sec, t3.tv_usec);
					}
				#endif
				repetitiontime[k] = t;
				t2.tv_sec = t3.tv_sec;
				t2.tv_usec = t3.tv_usec;



				gettimeofday(&t0, NULL);
                                ret = read(fd, inbuf, PESP_BUFFSIZE);
				gettimeofday(&t1, NULL);
				retvalues[k] = ret;
				#if 0
                                	t = ((float)(t1.tv_sec - t0.tv_sec))*1000  + ((float)t1.tv_usec - (float)t0.tv_usec)/1000;
				#else
			        	timersub(&t1, &t0, &tr);
					t = ((float)tr.tv_sec)*1000 + ((float)tr.tv_usec)/1000;
				#endif
				
				readtime[k] = t;			
				k++;
				if ( k >= MAX_VAL_BUFF ){
				  readtime_avg = 0;
				  for(i=0; i<k; i++){
					printf("%d :: img[%d] repetition %6.1f, read in %6.1f msec retvalue=%d\n", pid, i, repetitiontime[i], readtime[i], retvalues[i]);
					readtime_avg += readtime[i];
				  }
				  printf("......................read avg = %6.1f msec\n", readtime_avg/k);
				  k = 0;
				}
			};

			
		}
	}

    
  close(fd);

}

//=================================================================

void starthandler(int signum, siginfo_t *info, void *extra) {
	printf("start\n");
	go = 1;
}

void stophandler(int signum, siginfo_t *info, void *extra) {
	printf("stop\n");
	go = 0;
}


//#####################################################################################
