#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>


#include <errno.h>


void usage(){
          printf("\n");
          printf("Usage: millisleep tmo[ms]\n");
          printf("\n");
          exit(-1);
}

int main(int argc, char * argv[]){
	struct timeval tmo;
	int millis;

	if (argc < 2) usage();

	millis = atoi(argv[1]);

	tmo.tv_sec = millis / 1000;
	millis -= tmo.tv_sec * 1000;
	tmo.tv_usec = millis * 1000;

	//printf("tmo.tv_sec = %d\n", tmo.tv_sec);
	//printf("tmo.tv_usec = %d\n", tmo.tv_usec);

	if (select(0, NULL, NULL, NULL, &tmo) < 0) perror("select");
	else return (0);


	return (-1);
}
