
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include <unistd.h>

#include "pesp_ioctl.h"
#include "h_types_2.h"
#include "lib_h_image.h"



void usage(){
	  printf("setDark darkfile\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){

  h_metaimg_t pespDark;

  int hamaBuf_fd = 0;
  int retval;
  int fd0;

	if (argc < 2) usage();

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************
**********************************/

        retval = h_ImageFromFile(argv[1], &pespDark);
        printf("Got %d bytes from file %s\n", retval, argv[1]);

        retval = ioctl(hamaBuf_fd, PESP_IOCS_DARK, &pespDark);
        if (-1 == retval) {
                printf("%m on ioctl(PESP_IOCS_DARK)\n");
        }



    	close(hamaBuf_fd);
}

