
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"
#include "lib_h_image.h"



void usage(){
	  printf("\n");
	  printf("Usage: setImage image[raw]\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;
  int fd;
  h_img_t outbuf;
  int size;


	if (argc < 2) usage();

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);

	fd = open(argv[1], O_RDONLY);
	retval = read(fd, outbuf, PESP_BUFFSIZE);
        printf("retval/bytes read = %d\n", retval);
	close(fd);

	retval = write(hamaBuf_fd, outbuf, PESP_BUFFSIZE);
        printf("retval/written bytes = %d\n", retval);


    	close(hamaBuf_fd);
}
