
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"


void usage(){
	  printf("\n");
	  printf("Usage: setStage p2m value\n");
	  printf("      float pixel2micron\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;

	if (argc < 3) usage();

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************
**********************************/

	if ( strcmp(argv[1], "p2m") == 0 ) {
		float w;
			printf("Writing %s\n", argv[1]);
			sscanf(argv[2], "%f", &w);
        		retval = ioctl(hamaBuf_fd, PESP_IOCS_PIXEL2MICRON, &w);          
			printf("retval = %d\n", retval);
	} 


    	close(hamaBuf_fd);
}

