#include "pesp.h"

extern pespBuff_t pespBuff;
extern buff_Dt_t  buff_Dt[MAX_FD_NR];



//---------------------------------------------------------------------------
int pesp_release(struct inode *inode, struct file *filp)
{
  unsigned int dev_minor = iminor(inode);

  if (dev_minor == 0 ) { // pespImg0, vecchio device
	int ch = (uintptr_t)filp->private_data;
	printk(KERN_ALERT "pesp_release(): closed file descr. %d\n", ch);
	pespBuff.buff[ch].opened=-1;
	pespBuff.buff[ch].want_update = WANT_UPDATE_DFLT;
	pespBuff.buff[ch].pid=0;
	strncpy(pespBuff.buff[ch].comm, "-", sizeof(1));
        printk(KERN_ALERT "pesp_release(): close file on minor 0 by PID: %d : %s\n", current->pid, current->comm);
  	/* Success */
  	return 0;
  } else
  if (dev_minor == 1 ) { // pespDt0, nuovo device
	int ch = (uintptr_t)filp->private_data;
	printk(KERN_ALERT "pesp_release(): closed file descr. %d\n", ch);
	buff_Dt[ch-100].opened=-1;
        printk(KERN_ALERT "pesp_release(): close file on minor 1 by PID: %d : %s\n", current->pid, current->comm);
        return 0; /* Success */
  }
  return -ENXIO; /* No such device or address */
}
