
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include "pesp_ioctl.h"
#include "lib_h_image.h"



int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;

  h_metaimg_t metaimg;
  int size = 2050 * 2050 * 2;
  int data_offset = 0;
  unsigned char *img_data;
  unsigned char *img_buf;
  uint16_t * p = NULL;
  int k=0;
  int max  = -1;

  gc_t gc;

	if (argc == 2){
		hamaBuf_fd = open(argv[1], O_RDONLY);
	} else {
		hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
	}


	
	img_buf = malloc(size);
	retval = read(hamaBuf_fd, img_buf, size);
	if ( retval < 0 ){
		perror("");
		return -1;
	}
    	close(hamaBuf_fd);
	printf("retval/read = %d \n", retval);

	retval = h_ImageFromBuffer(img_buf, &metaimg, true);
	printf("retval/read = %d \n", retval);

	

	retval = h_dumpImageStruct(metaimg);

	printf("h_ImageGetImageSize= %ld\n", h_ImageGetImageSize(metaimg));

	img_data = h_ImageGetImage(metaimg); 
	printf("img_data= %p\n", img_data);

	retval = h_dumpImageInfo(metaimg);


#if 0
	p = (uint16_t *)(img_data);
	printf("p= %p\n", p);

	printf("max = %d\n", max);
	for (k=0; k<1000*1000; k++){
		if ((int)(p[k]) > 0 ) printf("%d\n", (int)(p[k]));
		//if ( (int)(p[k]) > max ) max = (int)(p[k]);
	}
	printf("max = %d\n", max);
#endif

}

