
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"
#include "ImageProc-c.h"



int main(){
  struct _pespccd ccd;
  struct _pesp hama;
  struct _pespInfo info;

  int v2_start;
  int v1_end;

  gc_t gc; 

	printf("size of ccd           : %d\n", sizeof(ccd));
	printf("size of _pespccd : %d\n", sizeof(struct _pespccd));

	printf("size of hama          : %d\n", sizeof(hama));
	printf("size of _pesp    : %d\n", sizeof(struct _pesp));

	printf("size of info          : %d\n", sizeof(info));
	printf("size of _pespInfo: %d\n", sizeof(struct _pespInfo));

	printf("size of gc            : %d\n", sizeof(gc));
	printf("size of gc_t          : %d\n", sizeof(gc_t));

	printf("size of double          : %d\n", sizeof(double));

/*
#define PESP_IMAGE_OFFSET          0
#define PESP_SPECTRUM_OFFSET       PESP_IMAGE_SIZE
#define PESP_INFO_OFFSET           (PESP_SPECTRUM_OFFSET + PESP_SPECTRUM_SIZE)
#define PESP_INFOINFO_OFFSET       PESP_INFO_OFFSET
#define PESP_INFOGC_OFFSET         (PESP_INFOINFO_OFFSET + 256 + 128)
#define PESP_V2_OFFSET             PESP_BUFFSIZE_V1
#define PESP_VSPECTRUM_OFFSET      PESP_V2_OFFSET
*/
	printf("\n");
	printf("PESP_IMAGE_OFFSET      = %d\n", PESP_IMAGE_OFFSET);
	printf("PESP_SPECTRUM_OFFSET   = %d\n", PESP_SPECTRUM_OFFSET);
	printf("PESP_INFO_OFFSET       = %d\n", PESP_INFO_OFFSET);
	printf("                 INFO end   = %d\n", PESP_INFO_OFFSET + sizeof(struct _pespInfo));
	printf("PESP_INFOGC_OFFSET     = %d\n", PESP_INFOGC_OFFSET);
	v1_end = PESP_INFOGC_OFFSET + sizeof(gc_t);
	printf("               GCINFO end   = %d\n", v1_end);
	printf("PESP_VSPECTRUM_OFFSET  = %d\n", PESP_VSPECTRUM_OFFSET);

	printf("\n");
	v2_start = PESP_BUFFSIZE_V1;
	printf("PESP_BUFFSIZE_V1 [%d] deve essere maggiore eguale a [%d] ... ", v2_start, v1_end);
	printf("%s\n", v2_start >= v1_end ? "ok" : "ATTENZIONE ERRORE");
	printf("\n");


	printf("PESP_PROFILES_OFFSET   = %d\n", PESP_PROFILES_OFFSET);
	printf("PESP_EXTRA_OFFSET      = %d\n", PESP_EXTRA_OFFSET);
	printf("\n");
	printf("PESP_BUFFSIZE          = %d\n", PESP_BUFFSIZE);

}

