
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"



int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;
  int size;

  h_img_t img;


	if (argc == 2){
		hamaBuf_fd = open(argv[1], O_RDONLY);
	} else {
		hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
	}

	retval = read(hamaBuf_fd, img, PESP_BUFFSIZE);
	printf("retval = %d ", retval);
	if ( retval == PESP_BUFFSIZE ) {
		printf(" ok\n");
	} else {
		printf(" not ok\n");
	}
    	close(hamaBuf_fd);

//=========================================================================
//
//
//#define PESP_SPECTRUM_SIZE_LONG 1000
//struct _pespSpectrum {
//        uint32_t spectrum[PESP_SPECTRUM_SIZE_LONG];
//};
	struct _pespSpectrum pespSpectrum;
	int k, j;

	size = PESP_SPECTRUM_SIZE;
	memcpy((unsigned char *)&pespSpectrum, (img+PESP_SPECTRUM_OFFSET), size);
	for (k=0; k<PESP_SPECTRUM_SIZE_LONG - 10; k += 10){
	  printf("Spectrum[%03d]= ", k);
	  for (j=0; j<10; j++)
		printf("%lu  ", pespSpectrum.spectrum[k+j]);
	  printf("\n");
	}
	

        printf("PESP_VSPECTRUM_OFFSET = %d\n", PESP_VSPECTRUM_OFFSET);
	size = PESP_SPECTRUM_SIZE;
	memset((void*)pespSpectrum.spectrum, 0, size);
	memcpy((unsigned char *)&pespSpectrum, (img+PESP_VSPECTRUM_OFFSET), size);
	for (k=0; k<PESP_SPECTRUM_SIZE_LONG - 10; k += 10){
	  printf("VSpectrum[%03d]= ", k);
	  for (j=0; j<10; j++)
		printf("%lu  ", pespSpectrum.spectrum[k+j]);
	  printf("\n");
	}

}

