
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"



int main(){
  int hamaBuf_fd = 0;
  stageInfo_t si;
  int retval;

  float w, ws;


	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************
struct _stageInfo {
	float wavelength;
	float wavelengthspan;
};
**********************************/

        retval = ioctl(hamaBuf_fd,PESP_IOCG_STAGEINFO, &si);          /* Get by pointer */
	//printf("retval = %d\n", retval);

	printf("si.wavelength        = %f\n", si.wavelength);
	printf("si.wavelengthspan    = %f\n", si.wavelengthspan);

        retval = ioctl(hamaBuf_fd,PESP_IOCG_WAVELENGTH, &w);          /* Get by pointer */
	//printf("retval = %d\n", retval);

	printf("wavelength           = %f\n", w);

        retval = ioctl(hamaBuf_fd,PESP_IOCG_WAVELENGTHSPAN, &ws);          /* Get by pointer */
	//printf("retval = %d\n", retval);
	printf("wavelengthspan       = %f\n", ws);

    	close(hamaBuf_fd);
}

