
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include "pesp_ioctl.h"



int main(){
  int hamaBuf_fd = 0;
  h_virt_ccd_t pesp;
  int retval;


	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************
struct _pesp {
        int width, height, depth;
        float acqframerate;
        bool darksubtract;
};

**********************************/

        retval = ioctl(hamaBuf_fd,PESP_IOCG_VCCD, &pesp);          /* Get by pointer */
	printf("retval = %d\n", retval);

	printf("pesp.width          = %d\n", pesp.width);
	printf("pesp.height         = %d\n", pesp.height);
	printf("pesp.depth          = %d\n", pesp.depth);
	printf("pesp.canvas.width   = %d\n", pesp.canvas.width);
	printf("pesp.canvas.height  = %d\n", pesp.canvas.height);
	printf("pesp.canvas.pivot.x = %d\n", pesp.canvas.pivot.x);
	printf("pesp.canvas.pivot.y = %d\n", pesp.canvas.pivot.y);
	printf("pesp.acqframerate   = %f\n", pesp.acqframerate);
	printf("pesp.darksubtract   = %d\n", pesp.darksubtract);
	printf("pesp.angle          = %f\n", pesp.angle);

    	close(hamaBuf_fd);
}

