
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>

#include "pesp_ioctl.h"
#include "lib_h_image.h"



int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;

  h_metaimg_t metaimg;
  int size = 2050 * 2050 * 2;
  int data_offset = 0;
  unsigned char *img_data;
  unsigned char *img_buf;
  uint16_t * p = NULL;
  int k=0;
  int max  = -1;
  int fd;
  char outfile[]="dev_pespImg0";
  bool f_outfile = false;
  char name[256] = "";
  int wr_size;

  gc_t gc;

	if (argc == 2){
		hamaBuf_fd = open(argv[1], O_RDONLY);
		f_outfile = true;
	} else {
		hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
		f_outfile = false;
	}


	
	img_buf = malloc(size);
	retval = read(hamaBuf_fd, img_buf, size);
	if ( retval < 0 ){
		perror("");
		return -1;
	}
    	close(hamaBuf_fd);
	printf("retval/read = %d \n", retval);
	wr_size = retval;

	//retval = h_ImageFromBuffer(img_buf, &metaimg, true);
	//printf("retval/read = %d \n", retval);

	if (f_outfile ){
     		strcat(name, argv[1]);
	} else {
     		strcat(name, outfile);
	}

        strncat(name, ".pesp", 256);
        fd = open(name, O_CREAT | O_RDWR | O_TRUNC, S_IRUSR | S_IWUSR);

        retval  = write(fd, img_buf, wr_size);

        printf("retval written = %d\n", retval);
        close(fd);


}

