
#include <string.h>
#include <stdlib.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include "pesp_ioctl.h"


void usage(){
	  printf("\n");
	  printf("Usage: setOYag int_value.x int_value.y\n");
	  printf("\n");
	  exit(-1);
}

int main(int argc, char *argv[]){
  int hamaBuf_fd = 0;
  int retval;
  ccd_point_t OYag;
  int x,y;

	if (argc < 3) usage();

	hamaBuf_fd = open("/dev/pespImg0", O_RDWR);
        if (hamaBuf_fd == -1) {
                perror("");
                return -1;
        }
        printf("hamaBuf_fd = %d\n", hamaBuf_fd);


/*********************************
**********************************/

	printf("Writing %s\n", argv[1]);
	sscanf(argv[1], "%d", &x);
	sscanf(argv[2], "%d", &y);

	OYag.x = x;
	OYag.y = y;

       	retval = ioctl(hamaBuf_fd, PESP_IOCS_OYAG, &OYag);          
	printf("retval = %d\n", retval);


    	close(hamaBuf_fd);
}

